from hash import hash
import random

def mine_asc(puzzle_id, target, min_nonce, max_nonce):

	for nonce in range(min_nonce,max_nonce):
		#nonce = random.randint(min_nonce,max_nonce)

		nonce = hex(nonce)

		to_hash = str(puzzle_id) + str(nonce)
		h = hash(bytes(to_hash, encoding='utf-8'))

		int_h = int(h.hex(), 16)
		int_target = int(str(target), 16)

		if (int_h < int_target):
			return nonce

	return False

def mine_desc(puzzle_id, target, min_nonce, max_nonce):

	for nonce in range(max_nonce,min_nonce,-1):
		#nonce = random.randint(min_nonce,max_nonce)

		nonce = hex(nonce)

		to_hash = str(puzzle_id) + str(nonce)
		h = hash(bytes(to_hash, encoding='utf-8'))

		int_h = int(h.hex(), 16)
		int_target = int(str(target), 16)

		if (int_h < int_target):
			return nonce

	return False

def mine_rand(puzzle_id, target, min_nonce, max_nonce):

	range = max_nonce - min_nonce
	num = 0

	while(num<range):

		nonce = random.randint(min_nonce,max_nonce)

		nonce = hex(nonce)

		to_hash = str(puzzle_id) + str(nonce)
		h = hash(bytes(to_hash, encoding='utf-8'))

		int_h = int(h.hex(), 16)
		int_target = int(str(target), 16)

		if (int_h < int_target):
			return nonce

		num += 1

	return False



ID = 0xfaa
TARGET = 0x0000000000000000ffffffffffffffffffffffffffffffffffffffffffffffff
c = 2**32
min = (11*c)//12
max = c - 1



#nonce = mine_asc(ID, TARGET, min, max)
nonce = mine_desc(ID, TARGET, min, max)
#nonce = mine_rand(ID, TARGET, min, max)

print(nonce)



##################
##### USED:#######
##################

######
####1:
######

#DESC BETTER THAN ASC
#ID = 0xabcdeeee
#TARGET = 0x000000000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
#c = 2**23
#min = 0
#max = c - 1
#solution = 0x284d83
#asc 
#13 sec

#ID = 0xabcdeeee
#TARGET = 0x000000000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
#c = 2**23
#min = 0
#max = c - 1
#solution = 0x72ea5c
#4sec
#desc

#ID = 0xabcdeeee
#TARGET = 0x000000000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
#c = 2**23
#min = 0
#max = c - 1
#solution = 0x5616eb most often
#varies
#rand

######
####2:
######

#No solution:
#ID = 0xabcdeeee
#TARGET = 0x0000000000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
#c = 2**23 #nonce size
#min = 0 #smallest nonce
#max = c - 1 #biggest nonce

######
####3:
######

# ASC better than DESC
#ID = 0xaaaaaaaa
#TARGET = 0x000000000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
#c = 2**23
#min = 0
#max = c - 1


######
####4:
######

#DESC WAY BETTER
#ID = 0xffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffff
#TARGET = 0x000000000000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
#c = 2**23
#min = 0
#max = c - 1


######
####5:
######

# DESC 1 min, ASC 1.5 min
#ID = 0xfaa
#TARGET = 0x0000000000000000ffffffffffffffffffffffffffffffffffffffffffffffff
#c = 2**32
#min = 0
#max = c - 1 


######
####6:
######

# ASC IN SECONDS; DESC 1 MIN
#ID = 0xfaa
#TARGET = 0x0000000000000000ffffffffffffffffffffffffffffffffffffffffffffffff
#c = 2**32
#min = (11*c)//12
#max = c - 1



######
####7:
######


#One long solution, also ASC way better
# Divide students in 12 groups to play with this, assign tasks and the mining function to use
#ID = 0xffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffff
#TARGET = 0x0000000000000000ffffffffffffffffffffffffffffffffffffffffffffffff
#c = 2**32
#min = (11*c)//(12)
#max = c - 1
#solution = 0xeb9cf413
#135sec asc